/*
  ==============================================================================

    This file was auto-generated!

  ==============================================================================
*/

#pragma once

#include "../JuceLibraryCode/JuceHeader.h"


class MainComponent : public Component, public Button::Listener
{
public:
    MainComponent()
    {
        openNested.setBounds (10, 10, 200, 100);
        openNested.addListener (this);
        addAndMakeVisible (openNested);
        setSize (openNested.getRight () + 10, openNested.getBottom () + 10);
    }

    ~MainComponent() {}

    void buttonClicked (Button* const /*b*/) override;

private:
    TextButton openNested {"Open nested window"};
    std::unique_ptr <DocumentWindow> nested;


    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (MainComponent)
};

//==============================================================================

class SecondaryWindow : public DocumentWindow
{
public:
    SecondaryWindow () :
    DocumentWindow ("Nested Window", Colours::darkgrey, DocumentWindow::closeButton)
    {
        setUsingNativeTitleBar (true);
        setContentNonOwned (&contentComponent, true);
    }

    void closeButtonPressed () override
    {
        jassert (isCurrentlyModal ());  // let's make sure we're still modal
        exitModalState (0);

        /* the alert sound is triggered by the following line.
         If I comment it, the sound doesn't happen, but the window stays visible
         which is not the desired behavior */
        setVisible (false);
    }

private:
    MainComponent contentComponent;
};
